From 481c1b6b36ebd47fa95f87a2490132636b443c77 Mon Sep 17 00:00:00 2001
From: qing zhao <qing.zhao@oracle.com>
Date: Wed, 24 Mar 2021 14:54:43 +0000
Subject: [PATCH] add -ftrivial-auto-var-init and variable attribute 
 uninitialized to gcc.


gcc/:

2021-03-24  qing zhao  <qing.zhao@oracle.com>

	* common.opt (ftrivial-auto-var-init=): New.
	(fauto-var-init-approach=): Likewise.
	* doc/extend.texi: Document the uninitialized attribute.
	* doc/invoke.texi: Document -ftrivial-auto-var-init.
	* expr.c (store_constructor): Clear the whole structure when
	-ftrivial-auto-var-init and the structure has paddings.
	* flag-types.h (enum auto_init_type): New enumerated type
	auto_init_type.
	(enum auto_init_approach): New enumerated type auto_init_approach.
	* gimple.h (enum gf_mask): Add GF_CALL_MEMSET_FOR_UNINIT case.
	(gimple_call_set_memset_for_uninit): New function.
	(gimple_call_memset_for_uninit_p): Likewise.
	* gimplify.c (gimplify_vla_decl): Add initialization to vla per users'
	requests. 
	(build_deferred_init): New function.
	(gimple_add_init_for_auto_var): Likewise.
	(gimplify_decl_expr): Add initialization to automatic variables per
	users' requests.
	(gimplify_init_constructor): Clear the whole structure when
	-ftrivial-auto-var-init and the structure has paddings.
	* internal-fn.c (expand_DEFERRED_INIT): New function.
	* internal-fn.def (DEFERRED_INIT): New internal function.
	* tree-cfg.c (verify_gimple_call): Skip calls to DEFERRED_INIT.
	* tree-core.h (tree_decl_with_vis): Add uninitialized field.
	* tree-sra.c (sra_stats): Add two new fields deferred_init and
	subtree_deferred_init.
	(generate_subtree_deferred_init): New function.
	(sra_modify_deferred_init): Likewise.
	(sra_modify_function_body): Handle calls to DEFERRED_INIT specially.
	* tree-ssa-structalias.c (find_func_aliases_for_deferred_init): New
	function.
	(find_func_aliases_for_call): Handle calls to DEFERRED_INIT specially.
	* tree-ssa-uninit.c (warn_uninit): Handle calls to DEFERRED_INIT
	specially.
	(check_defs): Handle calls to DEFERRED_INIT and MEMSET for uninitialized
	variable specially.
	(warn_uninitialized_vars): Handle calls to DEFERRED_INIT specially.
	* tree-ssa.c (ssa_undefined_value_p): Handle calls to DEFERRED_INIT
	specially.
	* tree.c (build_pattern_cst): New function.
	(type_has_padding): Likewise.
	* tree.h (DECL_UNINITIALIZED): New macro.
	(build_pattern_cst): New declaration.
	(type_has_padding): Likewise.

gcc/c-family/:

2021-03-24  qing zhao  <qing.zhao@oracle.com>

	* c-attribs.c (handle_uninitialized_attribute): New function.
	(c_common_attribute_table): Add "uninitialized" attribute.

gcc/testsuite/:

2021-03-24  qing zhao  <qing.zhao@oracle.com>

	* c-c++-common/auto-init-1.c: New test.
	* c-c++-common/auto-init-10.c: New test.
	* c-c++-common/auto-init-11.c: New test.
	* c-c++-common/auto-init-12.c: New test.
	* c-c++-common/auto-init-13.c: New test.
	* c-c++-common/auto-init-14.c: New test.
	* c-c++-common/auto-init-2.c: New test.
	* c-c++-common/auto-init-3.c: New test.
	* c-c++-common/auto-init-4.c: New test.
	* c-c++-common/auto-init-5.c: New test.
	* c-c++-common/auto-init-6.c: New test.
	* c-c++-common/auto-init-7.c: New test.
	* c-c++-common/auto-init-8.c: New test.
	* c-c++-common/auto-init-9.c: New test.
	* c-c++-common/auto-init-esra.c: New test.
	* g++.dg/auto-init-uninit-pred-1_a.C: New test.
	* g++.dg/auto-init-uninit-pred-1_b.C: New test.
	* g++.dg/auto-init-uninit-pred-2_a.C: New test.
	* g++.dg/auto-init-uninit-pred-2_b.C: New test.
	* g++.dg/auto-init-uninit-pred-3_a.C: New test.
	* g++.dg/auto-init-uninit-pred-3_b.C: New test.
	* g++.dg/auto-init-uninit-pred-4.C: New test.
	* g++.dg/auto-init-uninit-pred-loop-1_a.cc: New test.
	* g++.dg/auto-init-uninit-pred-loop-1_b.cc: New test.
	* g++.dg/auto-init-uninit-pred-loop-1_c.cc: New test.
	* g++.dg/auto-init-uninit-pred-loop_1.cc: New test.
	* gcc.dg/auto-init-uninit-1.c: New test.
	* gcc.dg/auto-init-uninit-11.c: New test.
	* gcc.dg/auto-init-uninit-12.c: New test.
	* gcc.dg/auto-init-uninit-13.c: New test.
	* gcc.dg/auto-init-uninit-14.c: New test.
	* gcc.dg/auto-init-uninit-15.c: New test.
	* gcc.dg/auto-init-uninit-16.c: New test.
	* gcc.dg/auto-init-uninit-17.c: New test.
	* gcc.dg/auto-init-uninit-18.c: New test.
	* gcc.dg/auto-init-uninit-19.c: New test.
	* gcc.dg/auto-init-uninit-2.c: New test.
	* gcc.dg/auto-init-uninit-20.c: New test.
	* gcc.dg/auto-init-uninit-21.c: New test.
	* gcc.dg/auto-init-uninit-22.c: New test.
	* gcc.dg/auto-init-uninit-23.c: New test.
	* gcc.dg/auto-init-uninit-24.c: New test.
	* gcc.dg/auto-init-uninit-25.c: New test.
	* gcc.dg/auto-init-uninit-26.c: New test.
	* gcc.dg/auto-init-uninit-3.c: New test.
	* gcc.dg/auto-init-uninit-34.c: New test.
	* gcc.dg/auto-init-uninit-36.c: New test.
	* gcc.dg/auto-init-uninit-37.c: New test.
	* gcc.dg/auto-init-uninit-4.c: New test.
	* gcc.dg/auto-init-uninit-5.c: New test.
	* gcc.dg/auto-init-uninit-6.c: New test.
	* gcc.dg/auto-init-uninit-8.c: New test.
	* gcc.dg/auto-init-uninit-9.c: New test.
	* gcc.dg/auto-init-uninit-A.c: New test.
	* gcc.dg/auto-init-uninit-B.c: New test.
	* gcc.dg/auto-init-uninit-C.c: New test.
	* gcc.dg/auto-init-uninit-H.c: New test.
	* gcc.dg/auto-init-uninit-I.c: New test.
	* gcc.target/aarch64/auto-init-1.c: New test.
	* gcc.target/aarch64/auto-init-10.c: New test.
	* gcc.target/aarch64/auto-init-11.c: New test.
	* gcc.target/aarch64/auto-init-12.c: New test.
	* gcc.target/aarch64/auto-init-13.c: New test.
	* gcc.target/aarch64/auto-init-14.c: New test.
	* gcc.target/aarch64/auto-init-15.c: New test.
	* gcc.target/aarch64/auto-init-16.c: New test.
	* gcc.target/aarch64/auto-init-17.c: New test.
	* gcc.target/aarch64/auto-init-18.c: New test.
	* gcc.target/aarch64/auto-init-19.c: New test.
	* gcc.target/aarch64/auto-init-2.c: New test.
	* gcc.target/aarch64/auto-init-20.c: New test.
	* gcc.target/aarch64/auto-init-3.c: New test.
	* gcc.target/aarch64/auto-init-4.c: New test.
	* gcc.target/aarch64/auto-init-5.c: New test.
	* gcc.target/aarch64/auto-init-6.c: New test.
	* gcc.target/aarch64/auto-init-7.c: New test.
	* gcc.target/aarch64/auto-init-8.c: New test.
	* gcc.target/aarch64/auto-init-9.c: New test.
	* gcc.target/i386/auto-init-1.c: New test.
	* gcc.target/i386/auto-init-10.c: New test.
	* gcc.target/i386/auto-init-11.c: New test.
	* gcc.target/i386/auto-init-12.c: New test.
	* gcc.target/i386/auto-init-13.c: New test.
	* gcc.target/i386/auto-init-14.c: New test.
	* gcc.target/i386/auto-init-15.c: New test.
	* gcc.target/i386/auto-init-16.c: New test.
	* gcc.target/i386/auto-init-17.c: New test.
	* gcc.target/i386/auto-init-18.c: New test.
	* gcc.target/i386/auto-init-19.c: New test.
	* gcc.target/i386/auto-init-2.c: New test.
	* gcc.target/i386/auto-init-20.c: New test.
	* gcc.target/i386/auto-init-3.c: New test.
	* gcc.target/i386/auto-init-4.c: New test.
	* gcc.target/i386/auto-init-5.c: New test.
	* gcc.target/i386/auto-init-6.c: New test.
	* gcc.target/i386/auto-init-7.c: New test.
	* gcc.target/i386/auto-init-8.c: New test.
	* gcc.target/i386/auto-init-9.c: New test.

---
 gcc/c-family/c-attribs.c                           |  21 ++
 gcc/common.opt                                     |  29 +++
 gcc/doc/extend.texi                                |  16 ++
 gcc/doc/invoke.texi                                |  34 ++-
 gcc/expr.c                                         |  17 +-
 gcc/flag-types.h                                   |  12 ++
 gcc/gimple.h                                       |  24 +++
 gcc/gimplify.c                                     | 191 +++++++++++++++++
 gcc/internal-fn.c                                  |  24 +++
 gcc/internal-fn.def                                |   5 +
 gcc/testsuite/c-c++-common/auto-init-1.c           |  39 ++++
 gcc/testsuite/c-c++-common/auto-init-10.c          |  17 ++
 gcc/testsuite/c-c++-common/auto-init-11.c          |  14 ++
 gcc/testsuite/c-c++-common/auto-init-12.c          |  14 ++
 gcc/testsuite/c-c++-common/auto-init-13.c          |  23 ++
 gcc/testsuite/c-c++-common/auto-init-14.c          |  23 ++
 gcc/testsuite/c-c++-common/auto-init-2.c           |  39 ++++
 gcc/testsuite/c-c++-common/auto-init-3.c           |  19 ++
 gcc/testsuite/c-c++-common/auto-init-4.c           |  19 ++
 gcc/testsuite/c-c++-common/auto-init-5.c           |  21 ++
 gcc/testsuite/c-c++-common/auto-init-6.c           |  21 ++
 gcc/testsuite/c-c++-common/auto-init-7.c           |  35 +++
 gcc/testsuite/c-c++-common/auto-init-8.c           |  35 +++
 gcc/testsuite/c-c++-common/auto-init-9.c           |  17 ++
 gcc/testsuite/c-c++-common/auto-init-esra.c        |  35 +++
 gcc/testsuite/g++.dg/auto-init-uninit-pred-1_a.C   |  63 ++++++
 gcc/testsuite/g++.dg/auto-init-uninit-pred-1_b.C   |  63 ++++++
 gcc/testsuite/g++.dg/auto-init-uninit-pred-2_a.C   |  62 ++++++
 gcc/testsuite/g++.dg/auto-init-uninit-pred-2_b.C   |  62 ++++++
 gcc/testsuite/g++.dg/auto-init-uninit-pred-3_a.C   |  77 +++++++
 gcc/testsuite/g++.dg/auto-init-uninit-pred-3_b.C   |  87 ++++++++
 gcc/testsuite/g++.dg/auto-init-uninit-pred-4.C     |  16 ++
 .../g++.dg/auto-init-uninit-pred-loop-1_a.cc       |  21 ++
 .../g++.dg/auto-init-uninit-pred-loop-1_b.cc       |  21 ++
 .../g++.dg/auto-init-uninit-pred-loop-1_c.cc       |  23 ++
 .../g++.dg/auto-init-uninit-pred-loop_1.cc         |  21 ++
 gcc/testsuite/gcc.dg/auto-init-uninit-1.c          |  30 +++
 gcc/testsuite/gcc.dg/auto-init-uninit-11.c         |  42 ++++
 gcc/testsuite/gcc.dg/auto-init-uninit-12.c         |  12 ++
 gcc/testsuite/gcc.dg/auto-init-uninit-13.c         |  10 +
 gcc/testsuite/gcc.dg/auto-init-uninit-14.c         |  20 ++
 gcc/testsuite/gcc.dg/auto-init-uninit-15.c         |  26 +++
 gcc/testsuite/gcc.dg/auto-init-uninit-16.c         |  23 ++
 gcc/testsuite/gcc.dg/auto-init-uninit-17.c         |  15 ++
 gcc/testsuite/gcc.dg/auto-init-uninit-18.c         |  24 +++
 gcc/testsuite/gcc.dg/auto-init-uninit-19.c         |  26 +++
 gcc/testsuite/gcc.dg/auto-init-uninit-2.c          |  52 +++++
 gcc/testsuite/gcc.dg/auto-init-uninit-20.c         |  18 ++
 gcc/testsuite/gcc.dg/auto-init-uninit-21.c         |  33 +++
 gcc/testsuite/gcc.dg/auto-init-uninit-22.c         |  69 ++++++
 gcc/testsuite/gcc.dg/auto-init-uninit-23.c         |  27 +++
 gcc/testsuite/gcc.dg/auto-init-uninit-24.c         |  10 +
 gcc/testsuite/gcc.dg/auto-init-uninit-25.c         |  23 ++
 gcc/testsuite/gcc.dg/auto-init-uninit-26.c         |  23 ++
 gcc/testsuite/gcc.dg/auto-init-uninit-3.c          |  33 +++
 gcc/testsuite/gcc.dg/auto-init-uninit-34.c         |  58 +++++
 gcc/testsuite/gcc.dg/auto-init-uninit-36.c         | 238 +++++++++++++++++++++
 gcc/testsuite/gcc.dg/auto-init-uninit-37.c         | 154 +++++++++++++
 gcc/testsuite/gcc.dg/auto-init-uninit-4.c          |  52 +++++
 gcc/testsuite/gcc.dg/auto-init-uninit-5.c          |  39 ++++
 gcc/testsuite/gcc.dg/auto-init-uninit-6.c          |  47 ++++
 gcc/testsuite/gcc.dg/auto-init-uninit-8.c          |  32 +++
 gcc/testsuite/gcc.dg/auto-init-uninit-9.c          |  42 ++++
 gcc/testsuite/gcc.dg/auto-init-uninit-A.c          | 117 ++++++++++
 gcc/testsuite/gcc.dg/auto-init-uninit-B.c          |  15 ++
 gcc/testsuite/gcc.dg/auto-init-uninit-C.c          |  21 ++
 gcc/testsuite/gcc.dg/auto-init-uninit-H.c          |  33 +++
 gcc/testsuite/gcc.dg/auto-init-uninit-I.c          |   8 +
 gcc/testsuite/gcc.target/aarch64/auto-init-1.c     |  32 +++
 gcc/testsuite/gcc.target/aarch64/auto-init-10.c    |  18 ++
 gcc/testsuite/gcc.target/aarch64/auto-init-11.c    |  27 +++
 gcc/testsuite/gcc.target/aarch64/auto-init-12.c    |  27 +++
 gcc/testsuite/gcc.target/aarch64/auto-init-13.c    |  22 ++
 gcc/testsuite/gcc.target/aarch64/auto-init-14.c    |  20 ++
 gcc/testsuite/gcc.target/aarch64/auto-init-15.c    |  20 ++
 gcc/testsuite/gcc.target/aarch64/auto-init-16.c    |  22 ++
 gcc/testsuite/gcc.target/aarch64/auto-init-17.c    |  21 ++
 gcc/testsuite/gcc.target/aarch64/auto-init-18.c    |  21 ++
 gcc/testsuite/gcc.target/aarch64/auto-init-19.c    |  27 +++
 gcc/testsuite/gcc.target/aarch64/auto-init-2.c     |  37 ++++
 gcc/testsuite/gcc.target/aarch64/auto-init-20.c    |  27 +++
 gcc/testsuite/gcc.target/aarch64/auto-init-3.c     |  19 ++
 gcc/testsuite/gcc.target/aarch64/auto-init-4.c     |  19 ++
 gcc/testsuite/gcc.target/aarch64/auto-init-5.c     |  19 ++
 gcc/testsuite/gcc.target/aarch64/auto-init-6.c     |  21 ++
 gcc/testsuite/gcc.target/aarch64/auto-init-7.c     |  32 +++
 gcc/testsuite/gcc.target/aarch64/auto-init-8.c     |  33 +++
 gcc/testsuite/gcc.target/aarch64/auto-init-9.c     |  19 ++
 gcc/testsuite/gcc.target/i386/auto-init-1.c        |  32 +++
 gcc/testsuite/gcc.target/i386/auto-init-10.c       |  19 ++
 gcc/testsuite/gcc.target/i386/auto-init-11.c       |  30 +++
 gcc/testsuite/gcc.target/i386/auto-init-12.c       |  30 +++
 gcc/testsuite/gcc.target/i386/auto-init-13.c       |  22 ++
 gcc/testsuite/gcc.target/i386/auto-init-14.c       |  22 ++
 gcc/testsuite/gcc.target/i386/auto-init-15.c       |  22 ++
 gcc/testsuite/gcc.target/i386/auto-init-16.c       |  22 ++
 gcc/testsuite/gcc.target/i386/auto-init-17.c       |  23 ++
 gcc/testsuite/gcc.target/i386/auto-init-18.c       |  21 ++
 gcc/testsuite/gcc.target/i386/auto-init-19.c       |  26 +++
 gcc/testsuite/gcc.target/i386/auto-init-2.c        |  37 ++++
 gcc/testsuite/gcc.target/i386/auto-init-20.c       |  26 +++
 gcc/testsuite/gcc.target/i386/auto-init-3.c        |  20 ++
 gcc/testsuite/gcc.target/i386/auto-init-4.c        |  23 ++
 gcc/testsuite/gcc.target/i386/auto-init-5.c        |  19 ++
 gcc/testsuite/gcc.target/i386/auto-init-6.c        |  22 ++
 gcc/testsuite/gcc.target/i386/auto-init-7.c        |  32 +++
 gcc/testsuite/gcc.target/i386/auto-init-8.c        |  33 +++
 gcc/testsuite/gcc.target/i386/auto-init-9.c        |  19 ++
 gcc/tree-cfg.c                                     |   3 +
 gcc/tree-core.h                                    |   3 +-
 gcc/tree-sra.c                                     | 132 +++++++++++-
 gcc/tree-ssa-structalias.c                         |  29 +++
 gcc/tree-ssa-uninit.c                              |  30 +++
 gcc/tree-ssa.c                                     |  17 ++
 gcc/tree.c                                         | 204 ++++++++++++++++++
 gcc/tree.h                                         |   6 +
 116 files changed, 4021 insertions(+), 18 deletions(-)
 create mode 100644 gcc/testsuite/c-c++-common/auto-init-1.c
 create mode 100644 gcc/testsuite/c-c++-common/auto-init-10.c
 create mode 100644 gcc/testsuite/c-c++-common/auto-init-11.c
 create mode 100644 gcc/testsuite/c-c++-common/auto-init-12.c
 create mode 100644 gcc/testsuite/c-c++-common/auto-init-13.c
 create mode 100644 gcc/testsuite/c-c++-common/auto-init-14.c
 create mode 100644 gcc/testsuite/c-c++-common/auto-init-2.c
 create mode 100644 gcc/testsuite/c-c++-common/auto-init-3.c
 create mode 100644 gcc/testsuite/c-c++-common/auto-init-4.c
 create mode 100644 gcc/testsuite/c-c++-common/auto-init-5.c
 create mode 100644 gcc/testsuite/c-c++-common/auto-init-6.c
 create mode 100644 gcc/testsuite/c-c++-common/auto-init-7.c
 create mode 100644 gcc/testsuite/c-c++-common/auto-init-8.c
 create mode 100644 gcc/testsuite/c-c++-common/auto-init-9.c
 create mode 100644 gcc/testsuite/c-c++-common/auto-init-esra.c
 create mode 100644 gcc/testsuite/g++.dg/auto-init-uninit-pred-1_a.C
 create mode 100644 gcc/testsuite/g++.dg/auto-init-uninit-pred-1_b.C
 create mode 100644 gcc/testsuite/g++.dg/auto-init-uninit-pred-2_a.C
 create mode 100644 gcc/testsuite/g++.dg/auto-init-uninit-pred-2_b.C
 create mode 100644 gcc/testsuite/g++.dg/auto-init-uninit-pred-3_a.C
 create mode 100644 gcc/testsuite/g++.dg/auto-init-uninit-pred-3_b.C
 create mode 100644 gcc/testsuite/g++.dg/auto-init-uninit-pred-4.C
 create mode 100644 gcc/testsuite/g++.dg/auto-init-uninit-pred-loop-1_a.cc
 create mode 100644 gcc/testsuite/g++.dg/auto-init-uninit-pred-loop-1_b.cc
 create mode 100644 gcc/testsuite/g++.dg/auto-init-uninit-pred-loop-1_c.cc
 create mode 100644 gcc/testsuite/g++.dg/auto-init-uninit-pred-loop_1.cc
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-1.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-11.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-12.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-13.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-14.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-15.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-16.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-17.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-18.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-19.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-2.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-20.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-21.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-22.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-23.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-24.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-25.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-26.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-3.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-34.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-36.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-37.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-4.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-5.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-6.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-8.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-9.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-A.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-B.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-C.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-H.c
 create mode 100644 gcc/testsuite/gcc.dg/auto-init-uninit-I.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-1.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-10.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-11.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-12.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-13.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-14.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-15.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-16.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-17.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-18.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-19.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-2.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-20.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-3.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-4.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-5.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-6.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-7.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-8.c
 create mode 100644 gcc/testsuite/gcc.target/aarch64/auto-init-9.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-1.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-10.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-11.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-12.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-13.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-14.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-15.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-16.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-17.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-18.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-19.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-2.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-20.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-3.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-4.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-5.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-6.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-7.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-8.c
 create mode 100644 gcc/testsuite/gcc.target/i386/auto-init-9.c

diff --git a/gcc/c-family/c-attribs.c b/gcc/c-family/c-attribs.c
index c1f652d..2a69e07 100644
--- a/gcc/c-family/c-attribs.c
+++ b/gcc/c-family/c-attribs.c
@@ -81,6 +81,7 @@ static tree handle_artificial_attribute (tree *, tree, tree, int, bool *);
 static tree handle_flatten_attribute (tree *, tree, tree, int, bool *);
 static tree handle_error_attribute (tree *, tree, tree, int, bool *);
 static tree handle_used_attribute (tree *, tree, tree, int, bool *);
+static tree handle_uninitialized_attribute (tree *, tree, tree, int, bool *);
 static tree handle_externally_visible_attribute (tree *, tree, tree, int,
 						 bool *);
 static tree handle_no_reorder_attribute (tree *, tree, tree, int,
@@ -329,6 +330,8 @@ const struct attribute_spec c_common_attribute_table[] =
 			      handle_used_attribute, NULL },
   { "unused",                 0, 0, false, false, false, false,
 			      handle_unused_attribute, NULL },
+  { "uninitialized",	      0, 0, true, false, false, false,
+			      handle_uninitialized_attribute, NULL },
   { "retain",                 0, 0, true,  false, false, false,
 			      handle_retain_attribute, NULL },
   { "externally_visible",     0, 0, true,  false, false, false,
@@ -1589,6 +1592,24 @@ handle_retain_attribute (tree *pnode, tree name, tree ARG_UNUSED (args),
   return NULL_TREE;
 }
 
+/* Handle a "uninitialized" attribute; arguments as in
+   struct attribute_spec.handler.  */
+
+static tree
+handle_uninitialized_attribute (tree *node, tree name, tree ARG_UNUSED (args),
+				int ARG_UNUSED (flags), bool *no_add_attrs)
+{
+  if (VAR_P (*node))
+    DECL_UNINITIALIZED (*node) = 1;
+  else
+    {
+      warning (OPT_Wattributes, "%qE attribute ignored", name);
+      *no_add_attrs = true;
+    }
+
+  return NULL_TREE;
+}
+
 /* Handle a "externally_visible" attribute; arguments as in
    struct attribute_spec.handler.  */
 
diff --git a/gcc/common.opt b/gcc/common.opt
index c75dd36..d0fc7bb 100644
--- a/gcc/common.opt
+++ b/gcc/common.opt
@@ -3049,6 +3049,35 @@ ftree-scev-cprop
 Common Var(flag_tree_scev_cprop) Init(1) Optimization
 Enable copy propagation of scalar-evolution information.
 
+ftrivial-auto-var-init=
+Common Joined RejectNegative Enum(auto_init_type) Var(flag_trivial_auto_var_init) Init(AUTO_INIT_UNINITIALIZED)
+-ftrivial-auto-var-init=[uninitialized|pattern|zero]	Add initializations to automatic variables.
+
+Enum
+Name(auto_init_type) Type(enum auto_init_type) UnknownError(unrecognized automatic variable initialization type %qs)
+
+EnumValue
+Enum(auto_init_type) String(uninitialized) Value(AUTO_INIT_UNINITIALIZED)
+
+EnumValue
+Enum(auto_init_type) String(pattern) Value(AUTO_INIT_PATTERN)
+
+EnumValue
+Enum(auto_init_type) String(zero) Value(AUTO_INIT_ZERO)
+
+fauto-var-init-approach=
+Common Joined RejectNegative Enum(auto_init_approach) Var(flag_auto_init_approach) Init(AUTO_INIT_D))
+-fauto-var-init-approach=[A|D]	Choose the approach to initialize automatic variables.
+
+Enum
+Name(auto_init_approach) Type(enum auto_init_approach) UnknownError(unrecognized automatic variable initialization approach %qs)
+
+EnumValue
+Enum(auto_init_approach) String(A) Value(AUTO_INIT_A)
+
+EnumValue
+Enum(auto_init_approach) String(D) Value(AUTO_INIT_D)
+
 ; -fverbose-asm causes extra commentary information to be produced in
 ; the generated assembly code (to make it more readable).  This option
 ; is generally only of use to those who actually need to read the
diff --git a/gcc/expr.c b/gcc/expr.c
index 92035c7..4a3516e 100644
--- a/gcc/expr.c
+++ b/gcc/expr.c
@@ -6566,14 +6566,19 @@ store_constructor (tree exp, rtx target, int cleared, poly_int64 size,
 	    cleared = 1;
 	  }
 
-        /* If the constructor has fewer fields than the structure or
-	   if we are initializing the structure to mostly zeros, clear
-	   the whole structure first.  Don't do this if TARGET is a
-	   register whose mode size isn't equal to SIZE since
-	   clear_storage can't handle this case.  */
+	/* If the constructor has fewer fields than the structure,
+	   or if we are initializing the structure to mostly zeros,
+	   or if the user requests to initialize automatic variables with
+	   paddings inside the type,
+	   we should clear the whole structure first.
+	   Don't do this if TARGET is a register whose mode size isn't equal
+	   SIZE since clear_storage can't handle this case.  */
 	else if (known_size_p (size)
 		 && (((int) CONSTRUCTOR_NELTS (exp) != fields_length (type))
-		     || mostly_zeros_p (exp))
+		     || mostly_zeros_p (exp)
+		     || (flag_trivial_auto_var_init > AUTO_INIT_UNINITIALIZED
+			 && !TREE_STATIC (exp)
+			 && type_has_padding (type)))
 		 && (!REG_P (target)
 		     || known_eq (GET_MODE_SIZE (GET_MODE (target)), size)))
 	  {
diff --git a/gcc/flag-types.h b/gcc/flag-types.h
index a038c8f..28e3231 100644
--- a/gcc/flag-types.h
+++ b/gcc/flag-types.h
@@ -242,6 +242,18 @@ enum vect_cost_model {
   VECT_COST_MODEL_DEFAULT = 1
 };
 
+/* Automatic variable initialization type.  */
+enum auto_init_type {
+  AUTO_INIT_UNINITIALIZED = 0,
+  AUTO_INIT_PATTERN = 1,
+  AUTO_INIT_ZERO = 2
+};
+
+enum auto_init_approach {
+  AUTO_INIT_A = 0,
+  AUTO_INIT_D = 1
+};
+
 /* Different instrumentation modes.  */
 enum sanitize_code {
   /* AddressSanitizer.  */
diff --git a/gcc/gimple.h b/gcc/gimple.h
index 3ec86f5..8e947bc 100644
--- a/gcc/gimple.h
+++ b/gcc/gimple.h
@@ -150,6 +150,7 @@ enum gf_mask {
     GF_CALL_BY_DESCRIPTOR	= 1 << 10,
     GF_CALL_NOCF_CHECK		= 1 << 11,
     GF_CALL_FROM_NEW_OR_DELETE	= 1 << 12,
+    GF_CALL_MEMSET_FOR_UNINIT	= 1 << 13,
     GF_OMP_PARALLEL_COMBINED	= 1 << 0,
     GF_OMP_TASK_TASKLOOP	= 1 << 0,
     GF_OMP_TASK_TASKWAIT	= 1 << 1,
@@ -3488,6 +3489,29 @@ gimple_call_alloca_for_var_p (gimple *s)
   return (gc->subcode & GF_CALL_ALLOCA_FOR_VAR) != 0;
 }
 
+/* If FOR_UNINIT is true, GIMPLE_CALL S is a call to builtin_memset that
+   is known to be emitted for unintialized VLA objects.  */
+
+static inline void
+gimple_call_set_memset_for_uninit (gcall *s, bool for_uninit)
+{
+  if (for_uninit)
+    s->subcode |= GF_CALL_MEMSET_FOR_UNINIT;
+  else
+    s->subcode &= ~GF_CALL_MEMSET_FOR_UNINIT;
+}
+
+/* Return true if S is a call to builtin_memset emitted for uninitialized
+   VLA objects.  */
+
+static inline bool
+gimple_call_memset_for_uninit_p (gimple *s)
+{
+  const gcall *gc = GIMPLE_CHECK2<gcall *> (s);
+  return (gc->subcode & GF_CALL_MEMSET_FOR_UNINIT) != 0;
+}
+
+
 /* If BY_DESCRIPTOR_P is true, GIMPLE_CALL S is an indirect call for which
    pointers to nested function are descriptors instead of trampolines.  */
 
